# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
def S4U::get_file_setting(dir_s4u_name,s4u_name)
	begin
		file_name = s4u_name + ".dat"
		file_name_full = File.join dir_s4u_name,file_name
		if File.exist?(file_name_full)
			file= File.new(file_name_full,"r")
			str=file.readlines
			file.close
			return str.collect{|s| s.chomp}
		end
		return false
	rescue
		return false
	end
end
def S4U::set_file_setting(dir_s4u_name,s4u_name,list)
	begin
		file_name = s4u_name + ".dat"
		file_name_full = File.join dir_s4u_name,file_name
		file= File.new(file_name_full,"w")
		list.each{|s| file.write(s.to_s+"\n")}
		file.close
		return true
	rescue
		return false
	end
end
module S4U
	module S4u_Divide
		#@@divide=[]#[[3,100.cm,100.cm],[1,200.cm,200.cm],[0,0],0]
		def self.find_connected(fa,sel=nil)
			faces=[fa]
			if sel
				all_connected=(fa.all_connected & sel).grep(Sketchup::Face).select{|f|
				(f.loops.collect{|l| l.edgeuses.collect{|e| e.edge}}.flatten).any?{|e| e.soft?}}
			else
				all_connected=fa.all_connected.grep(Sketchup::Face).select{|f|
				(f.loops.collect{|l| l.edgeuses.collect{|e| e.edge}}.flatten).any?{|e| e.soft?}}
			end
			i=0
			all_connected=all_connected-faces
			length=all_connected.length
			faces1=[fa]
			eds=[]
			while all_connected.length>0 && i<length
				faces2=[]
				eds1=[]
				faces1.each{|f|
					ed=f.loops.collect{|l| l.edgeuses.collect{|e| e.edge}}.flatten.select{|e| e.soft?}.uniq
					ed=ed - eds
					eds1 += ed
					faces2 += ed.collect{|e| e.faces}
				}
				faces2=faces2.flatten.uniq
				faces2= faces2-faces
				break if faces2.empty?
				faces1=faces2.clone
				eds=eds1.clone
				faces+=faces1
				all_connected=all_connected-faces1
				i+=1
			end
			return faces
		end
		def self.find_surface(fa,sel=nil)
			model=Sketchup.active_model
			faces_soft=[[[fa],nil]]
			faces=[fa]
			if sel
				all_connected=(fa.all_connected & sel).grep(Sketchup::Face).select{|f|
				(f.loops.collect{|l| l.edgeuses.collect{|e| e.edge}}.flatten).any?{|e| e.soft?}}
			else
				all_connected=fa.all_connected.grep(Sketchup::Face).select{|f|
				(f.loops.collect{|l| l.edgeuses.collect{|e| e.edge}}.flatten).any?{|e| e.soft?}}
			end
			i=0
			all_connected = all_connected - faces
			length=all_connected.length

			faces1=[fa]
			eds=[]
			while all_connected.length>0 && i<length
				faces2=[]
				eds1=[]
				faces1.each{|f|
					ed=f.loops.collect{|l| l.edgeuses.collect{|e| e.edge}}.flatten.select{|e| e.soft?}.uniq
					ed=ed - eds
					eds1 += ed
					fs= ed.collect{|e| e.faces}
					fs=fs.flatten.uniq
					fs= fs-faces
					if !fs.empty?
						faces_soft<<[fs,f]
						faces2+=fs
					end
				}
				faces2=faces2.flatten.uniq
				faces2= faces2-faces
				break if faces2.empty?
				faces1=faces2.clone
				eds=eds1.clone
				faces+=faces1
				all_connected=all_connected-faces1
				i+=1
			end
			return faces_soft,faces.uniq
		end
		class DivideFaces
			attr_accessor :origin,:xaxis,:yaxis,:zaxis
			def initialize(mode=0)
				cursor_path= File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse.pdf" : "icon_mouse.svg"))
				@cursor_id_blue = UI.create_cursor(cursor_path, 0, 0)
				cursor_path= File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse_red.pdf" : "icon_mouse_red.svg"))
				@cursor_id_red = UI.create_cursor(cursor_path, 0, 0)
				origin=ORIGIN
				xaxis=X_AXIS;yaxis=Y_AXIS,zaxis=Z_AXIS
				@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
				@snap= 20*@scale_factor
				@mode=mode
				@max_divide=50
				@min_divide=3
			end
			def activate
				model=Sketchup.active_model
				model.active_view.lock_inference if model.active_view.inference_locked?
				sels=model.selection.grep(Sketchup::Face)
				@edit_transform= Sketchup.version.to_i>=16 ? model.axes.transformation : model.edit_transform
				@strings=S4U::S4u_Divide::Strings
				@faces=[];@faces_hash={}
				if !sels.empty?
					@mode_list=[@strings["Fixed Number"],@strings["Max Distance"],@strings["Fixed Distance"],@strings["Random"]]
					@divide_axis=[@strings["Divide X"],@strings["Divide Y"],@strings["Rotation"]]
					@ip=Sketchup::InputPoint.new
					@multiselect=0
					@divide=[[3,100.cm,100.cm,100.cm],[1,200.cm,200.cm,100.cm]]
					@divide_mode=[0,0]
					reset(sels)
					if @mode==1
						@state=0
						@multiselect=1
						@divide_mode=[2,2]
						find_surface
					end
					self.setstatus(model.active_view)
				else
					@cancel=true
					model.select_tool nil
				end
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip && @ip.valid?
				return bb
			 end
			def reset(sels)
				model=Sketchup.active_model
				#sels=model.selection
				@state=0
				@axis=0
				@make_group=0
				@axis_divide=3
				dirname=File.dirname(__FILE__)
				name=(@mode==0) ? NAME : (NAME+'1')
				if dirname && (s=S4U::get_file_setting(dirname,name)) #&& s.length==7
					i=-1
					@divide[0]=eval s[i+=1]
					@divide[1]=eval s[i+=1]
					@divide_mode =eval s[i+=1]
					@make_group=eval s[i+=1]
					@axis_divide=s[i+=1].to_i
				else
					puts "no get setting"
				end
				get_origin(sels)
			end
			def center_face(face)
				vertices=get_vertices(face)
				return nil if !vertices
				numver=vertices.length
				cp=Geom::Point3d.new
				vertices.each{|v|
					cp.x=cp.x+v.position.x
					cp.y=cp.y+v.position.y
					cp.z=cp.z+v.position.z
				}
				cp.x=cp.x/ numver
				cp.y=cp.y/ numver
				cp.z=cp.z/ numver
				return cp
			end
			def get_vertices(face)
				return nil if not( face && (face.is_a?Sketchup::Face) && face.loops.length==1)
				ver=[]
				vertices=[]
				vertices =face.outer_loop.vertices*3
				(0..face.outer_loop.vertices.length-1).each { |i|
					j=face.outer_loop.vertices.length+i
					p1=vertices[j-1].position.clone
					p2=vertices[j].position.clone
					p3=vertices[j+1].position.clone
					v1=p1.vector_to p2
					v2=p2.vector_to p3
					ver.push vertices[j] if not( v1.samedirection? v2)
				}
				return ver
				rescue
				return nil
			end
			def get_origin(sels)
				model=Sketchup.active_model
				faces=sels.select{|e| (e.valid? && e.is_a?(Sketchup::Face))}
				#org= (Sketchup.version.to_i>=16) ? model.axes.origin : ORIGIN
				faces.each{|f|
					fd=S4U::S4u_Divide::Face_Divide.new(f)
					if fd
						@faces<<fd
						@faces_hash[f]=fd
					end
				}
				@faces.each{|f|
					f.set_origin()
					f.divide[0][0..-1],f.divide[1][0..-1]=@divide[0][0..-1],@divide[1][0..-1]
					f.divide_mode=@divide_mode
					f.make_grid(@axis_divide)
				}
			end
			def deactivate(view)
				if !@cancel
					divide
					dirname=File.dirname(__FILE__)
					name= (@mode==0) ? NAME : (NAME+'1')
					setting=[@divide[0],@divide[1],@divide_mode,@make_group,@axis_divide]
					(puts "error save setting") if not (dirname && S4U::set_file_setting(dirname,name,setting))
				end
			end
			def divide
				model=Sketchup.active_model
				entities=model.active_entities
				return if !@faces
				model.start_operation @strings[TOOL],true,false,false
				elements_old=model.active_entities.select{|f|  f.is_a?(Sketchup::Edge) || f.is_a?(Sketchup::Face)}
				edges=[]
				if @make_group==1
					grp_all=[]
					@faces.each{|f|
						grp=entities.add_group
						grp.transformation=f.trans_x ? f.trans_x : IDENTITY
						grp.name=@strings["Divide Faces"]
						grp.definition.name=@strings["Divide Faces"] if Sketchup.version.to_i>=15
						(f.lines[0]+f.lines[1]).each{|e|
							ed=grp.entities.add_edges( e[0].transform(grp.transformation.inverse),e[1].transform(grp.transformation.inverse))
							edges+= ed if ed
						}
						if grp && grp.valid?
							grp_all<<grp
						end
					}
					if !edges.empty?
						if grp_all.length==1
								model.selection.add grp_all
						else
							grp=entities.add_group grp_all
							if grp
								grp.name=@strings["Divide Faces"]
								grp.definition.name=@strings["Divide Faces"] if Sketchup.version.to_i>=15
								model.selection.add grp
							end
						end
					end
				else
					@faces.each{|f|
						if (f.lines[0]+f.lines[1]).length<50
							grp=entities.add_group
							grp.transformation=f.trans_x ? f.trans_x : IDENTITY
							#edges1=[]
							(f.lines[0]+f.lines[1]).each{|e|
								ed=grp.entities.add_edges( e[0].transform(grp.transformation.inverse),e[1].transform(grp.transformation.inverse))
								#edges1+= ed if ed
							}
							if grp && grp.valid?
								edges+=grp.explode.select{|e| e && e.valid? && e.is_a?(Sketchup::Edge)}
							end

						else
							edges=[]
							(f.lines[0]+f.lines[1]).each{|e|
								ed=model.active_entities.add_edges e
								edges+= ed if ed
							}
						end
					}
					edges.flatten!
					if !edges.empty?
						edges.each{|e| model.active_entities.intersect_with(false, IDENTITY, model.active_entities, IDENTITY,true,e) if e && e.valid? }
						# model.active_entities.intersect_with(false, IDENTITY, model.active_entities, IDENTITY,true,edges)
						elements_new= model.active_entities.select{|f| f && f.valid? && (f.is_a?(Sketchup::Edge) || f.is_a?(Sketchup::Face))}.uniq - elements_old
						elements_new+= elements_new.collect{|e| e.edges if e.is_a?Sketchup::Face}.flatten.uniq
						elements_new.compact!
						model.selection.add elements_new.flatten.select{|e| e && e.valid?}
					end
				end
				model.commit_operation
			end
			def onSetCursor
				if @state==3 || @state==4 || @state==5
					UI.set_cursor(@cursor_id_red)
				else
					UI.set_cursor(@cursor_id_blue)
				end
			end
			def getMenu(menu)#,flags, x, y, view)
				menus=[]
				@divide_axis.each_index{|j|
					if j<2
						submenu=menu.add_item(@divide_axis[j]){
							@axis_divide= @axis_divide ^ (j+1)
							if (@axis_divide & 1)==1
								@axis=0
							end
							if (@axis_divide & 2)==2
								@axis=1
							end
							@faces.each{|f| f.make_grid(@axis_divide)}
						}
						menu.set_validation_proc(submenu){ ((@axis_divide) & (j+1) == j+1) ? MF_CHECKED : MF_UNCHECKED}
					else
						submenu=menu.add_item(@divide_axis[j]){	@axis = @axis==2 ? ((@axis_divide & 1)==1? 0:1) : 2}
						menu.set_validation_proc(submenu){ @axis==2 ? MF_CHECKED : MF_UNCHECKED}
					end
					menu.add_separator
					menus<<submenu
					if j<2
						submenu=menu
						menus1=[]
						if ((@axis_divide) & (j+1) == j+1)
							@mode_list.each_index{|i|
								menus1<< submenu.add_item(@mode_list[i]){
									@axis=j
									@divide_mode[j]=i
									if @multiselect==0
										@faces.each{|f| f.make_grid(@axis_divide,nil,@divide_mode)}
									else
										@faces.each{|f| f.make_grid(@axis_divide,@divide,@divide_mode)}
									end
								}
							}
							menus1.each{|m| submenu.set_validation_proc(m) { MF_UNCHECKED }}
							submenu.set_validation_proc(menus1[@divide_mode[j]]){ MF_CHECKED }
							menu.add_separator
						end
					end
				}
				menus=[]
				m= menu.add_item(@strings["Multi Modifier Grid"]){ @multiselect=1-@multiselect }
				menu.set_validation_proc(m){ @multiselect==1 ? MF_CHECKED : MF_UNCHECKED }
				m= menu.add_item(@strings["Find Surface Grid"]){ @state=5 }
				menu.set_validation_proc(m){ MF_UNCHECKED }
				m= menu.add_item(@strings["Match Grid"]){ @state=3 }
				menu.set_validation_proc(m){ MF_UNCHECKED }
				m= menu.add_item(@strings["Make Group Divide Grid"]){ @make_group=1-@make_group }
				menu.set_validation_proc(m){ @make_group==1 ? MF_CHECKED : MF_UNCHECKED }
				menu.add_separator
				submenu=menu.add_submenu(@strings["Move Grid..."])
				m= submenu.add_item(@strings["Origin to CenterFace"]){ origin_to_centerface }
				submenu.set_validation_proc(m){ MF_UNCHECKED }
				m= submenu.add_item(@strings["Origin to Midle X axis"]){ origin_to_mid(0) }
				submenu.set_validation_proc(m){ MF_UNCHECKED }
				m= submenu.add_item(@strings["Origin to Midle Y axis"]){ origin_to_mid(1) }
				submenu.set_validation_proc(m){ MF_UNCHECKED }
				m= submenu.add_item(@strings["Move Origin..."]){ move_origin }
				submenu.set_validation_proc(m){ MF_UNCHECKED }
				menu.add_separator
				# ph = view.pick_helper
				# ph.do_pick(x, y)
				# selectface=ph.picked_face
				selectface=@ip.face
				if selectface && @faces_hash[selectface]
					m= menu.add_item(@strings["Reset Axis Current Face"]){ reset_axis(selectface) }
					menu.set_validation_proc(m){ MF_UNCHECKED }
				end
				m= menu.add_item(@strings["Reverse Axis"]){ reverse_axis }
				menu.set_validation_proc(m){ MF_UNCHECKED }
				m= menu.add_item(@strings["Reset Axis"]){ reset_axis }
				menu.set_validation_proc(m){ MF_UNCHECKED }
			end
			def move_origin
				model=Sketchup.active_model
				prompts = [@strings.GetString("Axis?"),@strings.GetString("Length?")]
				title=@strings.GetString("Move Origin")
				list=["X|Y",""]
				defaults = [['X','Y'][@axis],'1s']
				input = UI.inputbox(prompts,defaults,list,title)
				if input
					@axis=input[0]=='X'? 0 : 1
					if input[1][-1] == 's'
						length=parse_length(input[1][0..-1])
						@faces.each{|face|
							v= @axis==0 ? face.xaxis.clone: face.yaxis.clone
							v.length=length*face.step[@axis]
							p=face.origin + v
							face.set_origin_point(p)
							face.make_grid(@axis_divide)#(@divide,@divide_mode)
						} if length!=0
					else
						length=parse_length(input[1])
						@faces.each{|face|
							v= @axis==0 ? face.xaxis.clone: face.yaxis.clone
							v.length=length
							p=face.origin + v
							face.set_origin_point(p)
							face.make_grid(@axis_divide)#(@divide,@divide_mode)
						} if length!=0
					end
				end
			end
			def origin_to_centerface
				@faces.each{|face|
					face.set_origin_point(center_face face.face)
					face.make_grid(@axis_divide)#(@divide,@divide_mode)
				}
			end
			def origin_to_mid(axis)
				@faces.each{|face|
					if axis==0
						v=face.trans_x.yaxis.clone.reverse
						minmax=face.vertices.minmax_by{|v| v.position.transform(face.trans_x.inverse).y}.collect{|p| p.position.transform(face.trans_x.inverse)}
						dy=minmax[1].y-minmax[0].y
						v.length=dy*0.5
						p=center_face(face.face) + v
					else
						v=face.trans_y.xaxis.clone.reverse
						minmax=face.vertices.minmax_by{|v| v.position.transform(face.trans_y.inverse).x}.collect{|p| p.position.transform(face.trans_y.inverse)}
						dx=minmax[1].x-minmax[0].x
						v.length=dx*0.5
						p=center_face(face.face) + v
					end
					face.set_origin_point(p)
					face.make_grid(@axis_divide)#(@divide,@divide_mode)
				}
			end
			def reverse_axis
				@divide_mode=@divide_mode.reverse
				@faces.each{|face|
					t=face.xaxis
					face.xaxis=face.yaxis
					face.yaxis=t
					face.make_grid(@axis_divide)#(@divide,@divide_mode)
				}
			end
			def reset_axis(face=nil)
				if face
					@faces_hash[face].start=false
					@faces_hash[face].set_origin()
					@faces_hash[face].make_grid(@axis_divide)#(@divide,@divide_mode)
				else
					if @mode==0
						@faces.each{|face|
							face.start=false
							face.set_origin()
							face.make_grid(@axis_divide)#(@divide,@divide_mode)
						}
					else
						@faces[0].start=false
						@faces[0].set_origin()
						@faces[0].make_grid(@axis_divide)
						find_surface @faces[0]
					end
				end
			end
			def set_pointonedge(x,y,view,ip,edge)
				p1=edge.start.position.clone
				p2=edge.end.position.clone
				return nil if edge.length < (view.pixels_to_model(5*@snap, p1))
				points= [Geom.linear_combination(2.0/3, p1,1.0/3, p2),Geom.linear_combination(1.0/3, p1,2.0/3, p2)]
				ph = view.pick_helper
				ph.init(x, y)
				ph.do_pick(x, y)
				picked = points.find{|p| ph.test_point((p.transform ip.transformation),x,y,@snap) }
				if picked
					ip1=Sketchup::InputPoint.new(picked.transform ip.transformation)
					ip.copy! ip1
					view.tooltip="" + @strings["1/3"]
					return ip
				end
				return nil
			end
			def set_special_point(x,y,view,ip)
				@face =@edge =@point=nil
				if @state!=2 && !@face_move
					ph = view.pick_helper
					ph.init(x, y)
					ph.do_pick(x, y)
					pic =nil
					selectface=ph.picked_face
					select=@faces_hash[selectface] if selectface
					if select
						@axis_divide=(@axis_divide & 3)
						if ph.test_point(select.origin,x,y,@snap*3)
							ip1=Sketchup::InputPoint.new(select.origin)
							ip.copy! ip1
							@select_face=select
							view.tooltip=@strings["Origin"]
							@point=true
						elsif ph.test_point(select.axis_points[0],x,y,@snap*2)
							ip1=Sketchup::InputPoint.new(select.axis_points[0])
							ip.copy! ip1
							@select_face=select
							view.tooltip=@strings["Axis X"]
							@point=true
						elsif ph.test_point( select.axis_points[1],x,y,@snap*2)
							ip1=Sketchup::InputPoint.new(select.axis_points[1])
							ip.copy! ip1
							@select_face=select
							view.tooltip=@strings["Axis Y"]
							@point=true
						else
							picked=select.points.x.find{|p| ph.test_point(p,x,y,@snap*2)}
							if picked
								ip1=Sketchup::InputPoint.new(picked)
								@select_face=select
								@point=true
								view.tooltip=@strings["Divide X"]
								@axis_divide=@axis_divide+4
								ip.copy! ip1
							else
								picked=select.points.y.find{|p| ph.test_point(p,x,y,@snap*2)}
								if  picked
									@select_face=select
									ip1=Sketchup::InputPoint.new(picked)
									@point=true
									view.tooltip=@strings["Divide Y"]
									ip.copy! ip1
									@axis_divide=@axis_divide+8
								end
							end
						end
					end
				end
				if ip.face
					if cf=center_face(ip.face)
						cf=cf.transform ip.transformation
						ph = view.pick_helper
						ph.init(x, y)
						ph.do_pick(x, y)
						picked = ph.test_point(cf,x,y,@snap)
						if picked
							ip1=Sketchup::InputPoint.new(cf)
							@face=ip.face
							view.tooltip=@strings.GetString("Center Face")
							ip.copy! ip1
						else
							@edge=ip.face.edges.find{|e| set_pointonedge(x,y,view,ip,e) }
						end
					end
				elsif ip.edge
					@edge=set_pointonedge(x,y,view,ip,ip.edge)
				end
			end
			def setstatus(view=nil)
				text = @strings[TOOL]
				if @axis<2
					text+=" | "+ @strings["Axis Current"] +  ": " + ["X","Y"][@axis]
					text += " - " +  @mode_list[@divide_mode[@axis]]
					text +=  " (" + @strings["TAB->Toggle"] + ")"
				else
					text += " | " +  @strings["Rotation"]
				end
				if @state<3
					text+= " | " + @strings["Select Origin Point(Click Origin for set Axis)"]
				elsif @state==3 ||  @state==5
					text+= " | " + @strings["Select Match Face Source"]
					view.tooltip=@strings["Select Match Face Source"] if view
				elsif @state==4
					text+= " | " + @strings["Select Match Face Destination"]
					view.tooltip=@strings["Select Match Face Destination"] if view
				end
				text+= " | " + @strings["Input Value"]
				text+= @divide_mode[0]==0 ?	 ": x=#{@divide[0][@divide_mode.x]}" : ": x=#{@divide[0][@divide_mode.x].to_l}"
				text+= @divide_mode[1]==0 ?	 ": y=#{@divide[1][@divide_mode.y]}" : ": y=#{@divide[1][@divide_mode.y].to_l}"
				text+= " | " + @strings["Click out for finish match."] if @state==4
				Sketchup.status_text=text
				view.invalidate if view
			end
			def draw(view)
				view.line_width=2
				@faces.each{|f|
					if (@face_move==f || @ctrl_press) && @mode==0
						f.draw_origin(view,true)
					else
						f.draw_origin(view,false)
					end
					f.draw_grid(view)
				}
				if @ip && @ip.valid?
					if @face || @edge
						view.draw_points @ip.position, @scale_factor*8, 1, "red"
					elsif @point
						view.draw_points @ip.position, @scale_factor*8, 1, "red"
					elsif @ip.display?
						@ip.draw(view)
					end
				end
				if @state==1 && @face_select && @ip && @ip.valid?
					view.line_width=5
					view.drawing_color=["red","green","blue"][@axis]
					view.draw_line @face_select.origin,@ip.position
				end
			end
			def onMouseMove(flags, x, y, view)
				model=view.model
				@point=nil
				ip = view.inputpoint x,y
				if ip && ip.valid? #&& ip.display? #&& (ip.edge || ip.face)
					@ip.copy! ip
					if (ip.edge || ip.face)
						set_special_point(x,y,view,ip)
						@ip.copy! ip
					end
					if (flags & 1)==1
						if @face_move
							point=@ip.position.clone
							if !point.on_plane?(@face_move.face.plane)
								ray = view.pickray x, y
								point=Geom::intersect_line_plane(ray,@face_move.face.plane)
								ip=view.inputpoint(x,y)
								@ip.copy! ip
							end
							if point && point.on_plane?(@face_move.face.plane)
								if @multiselect==1
									pstart=@ip_start.transform @origins[@face_move][1].inverse
									pend=point.transform @origins[@face_move][1].inverse
									v=pend-pstart
									connected=S4U::S4u_Divide.find_surface(@face_move.face,faces=@faces.collect{|f| f.face})
									faces=connected[1].collect{|f| @faces_hash[f]}
									faces.each{|f|
										if f!=@face_move
											origin=ORIGIN + v
											p=origin.transform @origins[f][1]
											f.set_origin_point(p)
										else
											f.set_origin_point(point)
										end
										f.make_grid(@axis_divide)
									}
								else
									p = point.transform @origins[@face_move][1].inverse
									v=p-ORIGIN
									@faces.each{|f|
										if f==@face_move
											t=@origins[f][1]
											v=v.transform t
											p=@origins[f][0]+v
											f.set_origin_point(p)
											f.make_grid(@axis_divide)
										end
									}
								end
							end
							setstatus(view)
						end
					else
						if @state==2
							if @face_select1
								d2=0
								if @axis==0
									p =ip.position.project_to_line([@face_select1.origin,(@face_select1.origin+@face_select1.xaxis)])
									d2=p.distance(@face_select1.origin)
								elsif @axis==1
									p =ip.position.project_to_line([@face_select1.origin,(@face_select1.origin+@face_select1.yaxis)])
									d2=p.distance(@face_select1.origin)
								end
								if d2>0
									s=d2/@d1
									st=@step1[@axis]
									num_old=@d1/st
									num_new= num_old/s
									if num_new<100 && num_old<100 && num_new>0
										if @divide_mode[@axis]==0
											num_new=num_new.ceil
											@divide[@axis][@divide_mode[@axis]] = num_new
										else
											@divide[@axis][@divide_mode[@axis]] = st*s
										end
										if @multiselect==1
											@faces.each{|f|
												f.divide_mode[@axis]=@divide_mode[@axis]
												f.divide[@axis][@divide_mode[@axis]]=@divide[@axis][@divide_mode[@axis]]
												f.make_grid(@axis_divide,f.divide,f.divide_mode)
												}
										else
											@face_select1.divide_mode[@axis]=@divide_mode[@axis]
											@face_select1.divide[@axis][@divide_mode[@axis]]=@divide[@axis][@divide_mode[@axis]]
											@face_select1.make_grid(@axis_divide)
										end
										if @divide_mode[@axis]==0
											view.tooltip= @strings["Segments"]+ " : " + @face_select1.divide[@axis][@divide_mode[@axis]].to_i.to_s + "\n" +@strings["Length"]+" : "+ @face_select1.step[@axis].to_l.to_s
										else
											view.tooltip= @strings["Length"]+" : "+ @face_select1.step[@axis].to_l.to_s
										end
									end
								end

							end
						end
					end
					setstatus(view)
				end
			end
			def onLButtonDown(flags, x, y, view)
				view.lock_inference if view.inference_locked?
				ctrl_face=nil
				if @ctrl_press && @state==4
					@face_match=nil
					face_match=nil
					ph = view.pick_helper
					ph.do_pick x,y
					face_match=@faces_hash[ph.picked_face] if ph.picked_face
					if face_match
						@face_match=face_match
						@state= 4
					end
				elsif @ctrl_press
						ph = view.pick_helper
						ph.do_pick x,y
						face=nil
						if @faces.length==1
							face=@faces[0]
						else
							selectface=ph.picked_face
							face=@faces_hash[selectface]
						end
						if face
							pl=face.face.classify_point(@ip.position)
							if pl==1 || pl==2 || pl==4 || pl==16
								v=face.vertices.find{|v| ph.test_point(v.position,x,y,@snap*3)}
								v ? face.set_origin_point(v.position) : face.set_origin_point(@ip.position)
								if @mode==0
									face.make_grid(@axis_divide)#(@divide,@divide_mode)
								else
									face.make_grid(@axis_divide)
									@state=5
									ctrl_face=face
									#find_surface(face)
								end
								setstatus(view)
							end
						end
				end
				if @state==0
					select_origin(x, y, view)
					setstatus(view)
				elsif @state==1
					select_origin(x, y, view)
					setstatus(view)
				elsif @state==2
					@face_select1=nil
					@point=@face=@edge=nil
					@state=0
					setstatus(view)
				elsif @state==3
					ph = view.pick_helper
					ph.do_pick x,y
					selectface=ph.picked_face
					face=@faces_hash[selectface]
					if face
						if @multiselect==1
							@faces.each{|f| f.copy(face) if f!=face}
							@state=0
						else
							@face_match=face
							face.start=true
							@state=4
						end
					end
				elsif @state==4
					ph = view.pick_helper
					ph.do_pick x,y
					selectface=ph.picked_face
					if selectface && face=@faces_hash[selectface]
						if face!=@face_match
							face.copy(@face_match)
						end
					else
						@state=0
					end
				elsif @state==5
					ph = view.pick_helper
					ph.do_pick x,y
					selectface=ph.picked_face
					if (ctrl_face && (face=ctrl_face)) || (selectface && face=@faces_hash[selectface])
						find_surface(face)
						setstatus(view)
					end
					@state=0
				end
			end
			def select_origin(x, y, view)
				ph = view.pick_helper
				ph.init(x, y)
				ph.do_pick x,y
				selectface=ph.picked_face
				if @state==0
					select_origin=nil;select_x=nil;select_y=nil;select=nil
					if @faces.length==1
						@face_select=@faces[0]
						if ph.test_point(@face_select.origin,x,y,@snap*3)
							@face_move=@face_select
							@ip_start=@ip.position.clone
							@origins={}
							@faces.each{|f| @origins[f]=[f.origin.clone,f.trans_x.clone]}
						else
							select_x=@face_select if ph.test_point(@face_select.axis_points[0],x,y,@snap*2)
							select_y=@face_select if ph.test_point(@face_select.axis_points[1],x,y,@snap*2)
							if select_x && select_y
								@axis = (select_x.axis_points[0].distance(@ip.position)<=select_y.axis_points[1].distance(@ip.position)) ? 0 : 1
								@state=1
							elsif select_x
								@axis=0
								@state=1
							elsif select_y
								@axis=1
								@state=1
							elsif @point
								point_x=@face_select.points.x.find{|p| ph.test_point(p,x,y,@snap*3)}
								if point_x
									@d1=point_x.distance(@face_select.origin)
									@axis=0
									@face_select1= @face_select
									@step1=@face_select.step.clone
									@state=2
									if @multiselect==1
										@start_state_2=@faces.collect{|f| [f,f.divide[@axis][f.divide_mode[@axis]]] }
									else
										@start_state_2=@face_select1.divide[@axis][@face_select1.divide_mode[@axis]]
									end
								else
									point_y=@face_select.points.y.find{|p| ph.test_point(p,x,y,@snap*3)}
									if point_y
										@d1=point_y.distance(@face_select.origin)
										@axis=1
										@face_select1= @face_select
										@step1=@face_select.step.clone
										@state=2
										if @multiselect==1
											@start_state_2=@faces.collect{|f| [f,f.divide[@axis][f.divide_mode[@axis]]] }
										else
											@start_state_2=@face_select1.divide[@axis][@face_select1.divide_mode[@axis]]
										end
									end
								end
							end
						end
					elsif @select_face || selectface
						select =@select_face ? [@select_face] : [@faces_hash[selectface]]
						select_origin=select.select{|f| ph.test_point(f.origin,x,y,@snap*3)}
						if select[0] && select_origin[0]
							@face_move=select_origin[0]
							@ip_start=@face_move.origin.clone
							@origins={}
							@faces.each{|f| @origins[f]=[f.origin.clone,f.trans_x.clone]}
						else
							select_x=select.find{|f| ph.test_point(f.axis_points[0],x,y,@snap*2)}
							select_y=select.find{|f| ph.test_point(f.axis_points[1],x,y,@snap*2)}
							if select_x && select_y
								if select_x.axis_points[0].distance(@ip.position)<=select_y.axis_points[1].distance(@ip.position)
									@axis=0
									@face_select=select_x
									@state=1
								else
									@axis=1
									@face_select=select_y
									@state=1
								end
							elsif select_x
								@axis=0
								@face_select=select_x
								@state=1
							elsif select_y
								@axis=1
								@face_select=select_y
								@state=1
							elsif select[0] && @point
								p = nil
								point_x=select.find{|f| p=f.points.x.find{|p| ph.test_point(p,x,y,@snap*3)} }
								if p && point_x
									@face_select1= select[0]
									@d1=p.distance(@face_select1.origin)
									@axis=0
									@step1=@face_select1.step.clone
									@state=2
									if @multiselect==1
										@start_state_2=@faces.collect{|f| [f,f.divide[@axis][f.divide_mode[@axis]]] }
									else
										@start_state_2=@face_select1.divide[@axis][@face_select1.divide_mode[@axis]]
									end
								else
									point_y=select.find{|f| p =f.points.y.find{|p| ph.test_point(p,x,y,@snap*3)} }
									if p && point_y
										@face_select1= select[0]
										@d1=p.distance(@face_select1.origin)
										@axis=1
										@step1=@face_select1.step.clone
										@state=2
										if @multiselect==1
											@start_state_2=@faces.collect{|f| [f,f.divide[@axis][f.divide_mode[@axis]]] }
										else
											@start_state_2=@face_select1.divide[@axis][@face_select1.divide_mode[@axis]]
										end
									end
								end
							end
						end
					end
				elsif @state==1 && @face_select
					point=@ip.position.project_to_plane(@face_select.face.plane)
					axis=nil
					axis= (point-@face_select.origin) if point && @face_select.origin!=point
					return if !axis
					if @axis==0
						@face_select.xaxis=axis if !@face_select.yaxis.parallel?(axis)
					elsif @axis==1
						@face_select.yaxis=axis if !@face_select.xaxis.parallel?(axis)
					else
						degrees=@face_select.xaxis.angle_between(axis)
						degrees = -degrees if degrees!=0 && axis.cross(@face_select.xaxis).samedirection?(@face_select.zaxis)
						trans=Geom::Transformation.rotation(@face_select.origin,@face_select.zaxis,degrees)*@face_select.transformation
						@face_select.transformation=trans
					end
					if @multiselect==1
						@faces.each{|f|
							origin=f.origin.clone
							f.copy(@face_select,false)
							f.set_origin_point origin
							f.make_grid(@axis_divide,@divide,@divide_mode)
						}
					else
						@face_select.make_grid(@axis_divide,@divide,@divide_mode)
					end
					@state=0
				end
			end
			def find_surface(face=nil)
				model=Sketchup.active_model
				if !face
					faces=@faces.collect{|f| f.face}
					length=faces.length
					i=0
					while faces.length>0 && i<length
						fa=faces.min_by{|f| f.edges.collect{|e| e.faces}.compact.uniq.length}
						face=@faces_hash[fa] if fa
						# face=@faces[0] if !face
						face_soft,faces_connected=S4U::S4u_Divide.find_surface(face.face,faces)
						faces=faces-faces_connected
						face_soft.each{|fs|
							fs[0].each{|f|
								@faces_hash[f].copy @faces_hash[fs[1]] if fs[1]
								@faces_hash[f].start=false
							}
						}
						if @faces_hash[face_soft[0][0][0]]
							@faces_hash[face_soft[0][0][0]].start=true
						else
							face.start=true
						end
						i+=1
					end
					# face.start=true
				else
					face_soft,faces_connected=S4U::S4u_Divide.find_surface(face.face,@faces.collect{|f| f.face})
					face_soft.each{|fs|
						fs[0].each{|f|
							@faces_hash[f].copy @faces_hash[fs[1]] if fs[1]
							@faces_hash[f].start=false
						}
					}
					face.start=true

				end
			end
			def onLButtonUp(flags, x, y, view)
				@face_move=nil
				#@faces.each{|face| face.make_grid(@divide,@divide_mode)}
				#setstatus(view)
			end
			def onLButtonDoubleClick(flags, x, y, view)
				ph = view.pick_helper
				ph.do_pick x,y
				selectface=ph.picked_face
				if selectface
					face=@faces_hash[selectface]
					if face
						t=face.xaxis
						face.xaxis=face.yaxis
						face.yaxis=t
						face.make_grid(@axis_divide)#(@divide,@divide_mode)
						find_surface(face) if @mode==1
						setstatus(view)
					end
				end
			end
			def onReturn(view)
				Sketchup.active_model.select_tool nil
			end
			def parse_length(input)
					(return 0) if !input
					input=input.to_s
					if !Sketchup.parse_length("1.1")
						input.gsub!(/\./, ',')
					else
						input.gsub!(/\,/, '.')
					end
					begin
						value=input.to_l
					rescue
						value=input.to_f
					end
					return value
				end
			def onUserText(text, view)
				if @state==0 || @state==2
					if text.include?(',')
						input=text.split(',')
						x=((@divide_mode[0]>0 ? (parse_length(input[0])) : input[0].to_f) )if input[0] && input[0].to_f>0
						y=((@divide_mode[1]>0 ? (parse_length(input[1])) : input[1].to_f) )if input[1] && input[1].to_f>0
						if (@divide_mode[0]>0 && x<@min_divide) || (@divide_mode[1]>0 && y<@min_divide)
							result =UI.messagebox( @strings["Small Distance.\nDo you want divide?"] , MB_YESNO)
							return if result == IDNO
						end
						if (@divide_mode[0]==0 && x>@max_divide) || (@divide_mode[1]==0 && y>@max_divide)
							result =UI.messagebox( @strings["Segments > 50.\nDo you want divide?"] , MB_YESNO)
							return if result == IDNO
						end
						@divide[0][@divide_mode[0]]=x
						@divide[1][@divide_mode[1]]=y
						@faces.each{|f| f.make_grid(@axis_divide,@divide,@divide_mode)}
					elsif @axis==0
						input= @divide_mode[@axis]>0 ? parse_length(text) : text.to_f
						if input>0
							if @divide_mode[@axis]==0
								if input>@max_divide
									result =UI.messagebox( @strings["Segments > 50.\nDo you want divide?"] , MB_YESNO)
									return if result == IDNO
								end
							else
								if input<@min_divide
									result =UI.messagebox( @strings["Small Distance.\nDo you want divide?"] , MB_YESNO)
									return if result == IDNO
								end
							end
							@divide[@axis][@divide_mode.x] = input
							if @multiselect==1 || @state==0
								@faces.each{|f| f.make_grid(@axis_divide,@divide,@divide_mode)}
								@state=0
							elsif @state==2 && @face_select1
								@face_select1.make_grid(@axis_divide,@divide,@divide_mode)
								@state=0
							end
						end
					elsif @axis==1
						input= @divide_mode[@axis]>0 ? parse_length(text) : text.to_f
						if input>0
							if  @divide_mode[@axis]==0
								if input>50
									result =UI.messagebox( @strings["Segments > 50.\nDo you want divide?"] , MB_YESNO)
									return if result == IDNO
								end
							else
								if input<4
									result =UI.messagebox( @strings["Small Distance.\nDo you want divide?"] , MB_YESNO)
									return if result == IDNO
								end
							end
							@divide[@axis][@divide_mode.y] = input
							if @multiselect==1 || @state==0
								@faces.each{|f| f.make_grid(@axis_divide,@divide,@divide_mode)}
								@state=0
							elsif @state==2 && @face_select1
								@face_select1.make_grid(@axis_divide,@divide,@divide_mode)
								@state=0
							end
						end
					elsif @axis==2
						degrees=text.to_f.degrees
						if @multiselect==1 || @state==0
							@faces.each{|f|
								trans=(Geom::Transformation.rotation(f.origin,f.zaxis,degrees))*f.transformation
								f.transformation=trans
								f.make_grid(@axis_divide)
							}
						elsif @state==2 && @face_select1
							f=@face_select1
							trans=(Geom::Transformation.rotation(f.origin,f.zaxis,degrees))*f.transformation
							f.transformation=trans
							f.make_grid(@axis_divide)
							@state=0
						end
					end
					setstatus(view)
				elsif @state==1
					degrees=text.to_f.degrees
					if @axis==0
						if @multiselect==1
							@faces.each{|f|
								xaxis=f.xaxis.transform (Geom::Transformation.rotation(f.origin,f.zaxis,degrees))
								f.xaxis=xaxis if !xaxis.parallel?(f.yaxis)
								f.make_grid(@axis_divide)
							}
						else
							if f=@select_face
								xaxis=f.xaxis.transform (Geom::Transformation.rotation(f.origin,f.zaxis,degrees))
								f.xaxis=xaxis if !xaxis.parallel?(f.yaxis)
								f.make_grid(@axis_divide)
							end
						end
					elsif @axis==1
						if @multiselect==1
							@faces.each{|f|
								yaxis=f.yaxis.transform (Geom::Transformation.rotation(f.origin,f.zaxis,degrees))
								f.yaxis=yaxis if !yaxis.parallel?(f.xaxis)
								f.make_grid(@axis_divide)
							}
						else
							if f=@select_face
								yaxis=f.yaxis.transform (Geom::Transformation.rotation(f.origin,f.zaxis,degrees))
								f.yaxis=yaxis if !yaxis.parallel?(f.xaxis)
								f.make_grid(@axis_divide)
							end
						end
					elsif @axis==2
						degrees=text.to_f.degrees
						@faces.each{|f|
							trans=(Geom::Transformation.rotation(f.origin,f.zaxis,degrees))*f.transformation
							f.transformation=trans
							f.make_grid(@axis_divide)
						}
					end
					setstatus(view)
					@state=0
				end
			end
			def resume(view)
				setstatus(view)
			end
			def onKeyUp(key, repeat, flags, view)
				if key==CONSTRAIN_MODIFIER_KEY
					view.lock_inference if view.inference_locked?
				elsif ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
					@ctrl_press=false
				end
				#setstatus(view)
			end
			def onKeyDown(key, repeat, flags, view)
				if ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
					@ctrl_press=true
				elsif key==9
					if @state==0
						@axis = @axis>0 ? 0 : 1
					else
						@axis = @axis>1 ? 0 : @axis+1
					end
					@faces.each{|f| f.make_grid(@axis_divide,@divide) } if @multiselect==1 #(@divide,@divide_mode)}
					self.setstatus(view)
				elsif key==VK_UP
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0
						p = @face_select.origin
						p1=p + @edit_transform.zaxis
						ip1 = Sketchup::InputPoint.new(p1)
						ip = Sketchup::InputPoint.new(p)
						view.lock_inference ip1,ip
					end
				elsif key==VK_LEFT
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0
						p = @face_select.origin
						p1=p + @edit_transform.yaxis
						ip1 = Sketchup::InputPoint.new(p1)
						ip = Sketchup::InputPoint.new(p)
						view.lock_inference ip1,ip
					end
				elsif key==VK_RIGHT
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0
						p = @face_select.origin
						p1=p + @edit_transform.xaxis
						ip1 = Sketchup::InputPoint.new(p1)
						ip = Sketchup::InputPoint.new(p)
						view.lock_inference ip1,ip
					end
				end
				#setstatus(view)
			end
			def onCancel(reason, view)
				if @state==0
					@cancel=true
					Sketchup.active_model.select_tool nil
				elsif @state==2 && @start_state_2
					if @multiselect==1
						@start_state_2.each{|f,d|
							f.divide[@axis][f.divide_mode[@axis]] = d
							f.make_grid(@axis_divide)
						}
					else
						@face_select1.divide[@axis][@face_select1.divide_mode[@axis]]=@start_state_2
						@face_select1.make_grid(@axis_divide)
					end
					@start_state_2=nil
					@state=0
					@ctrl_press=nil
				else
					@state=0
					@ctrl_press=nil
				end
				view.lock_inference if view.inference_locked?
				setstatus(view)
			end
		end #end class
		class Face_Divide
			attr_accessor :xaxis,:yaxis,:zaxis,:origin,:vertices,:face,:origin_index,:rever,:start,:divide,:divide_mode
			attr_reader :numver,:vx,:vy,:polygon,:parallel,:transformation,:minmax_x,:minmax_y,:lines,:axis_points,:step,:points,:trans_x,:trans_y,:dx,:dy
			def initialize(face)
				@face=face
				@instance=nil
				@vertices=self.get_vertices
				@numver=@vertices.length
				@origin_index=0
				@show_origin=false
				@start=false
				@origin=@vertices[0].position
				@zaxis=@face.normal
				cp=self.polygon?
				@parallel=self.parallel?
				@origin=cp if @polygon and (@numver>4)
				@rever=0
				@lines=[[],[]]
				@step=[1,1]
				@divide=[[1,1,1,1],[1,1,1,1]]
				@divide_mode=[0,0]
				@axis_divide=3
				setvar(true)
				arrange
				set_axis_points
			end
			def set_origin_point(point)
				p=point.project_to_plane @face.plane
				if p
					@origin=p
					@transformation=transformation
					@minmax_x=@vertices.minmax_by{|v| v.position.transform(@trans_x.inverse).x}
					@minmax_y=@vertices.minmax_by{|v| v.position.transform(@trans_y.inverse).y}
				end
				return p
			end
			def transformation
				return Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
			end
			def transformation=(trans)
				@transformation=trans
				@xaxis,@yaxis,@zaxis,@origin=trans.xaxis,trans.yaxis,trans.zaxis,trans.origin
			end
			def axes_edit_transform
				model=Sketchup.active_model
				return model.axes.transformation if Sketchup.version.to_i>=16
				model.start_operation "get edit transform"
				ents=model.active_entities
				begin
					g=ents.add_group(ents.add_group)
					t=Geom::Transformation.new(g.transformation.xaxis,g.transformation.yaxis,g.transformation.zaxis,g.transformation.origin)
					g.erase! if g && g.valid? && !g.deleted?
				rescue
					t=model.edit_transform
				end
				model.abort_operation
				return t
			end
			def arrange
				model=Sketchup.active_model
				ents=model.active_entities
				face=@face
				t= axes_edit_transform.inverse
				vectorz= t.zaxis
				if @face.normal.parallel? vectorz
					vers=@vertices.sort{|a,b| (a.position.transform t).y <=> (b.position.transform t).y}
					if ((vers[0].position.transform t).x < (vers[1].position.transform t).x ) ||
					((vers[0].position.transform t).x == (vers[1].position.transform t).x and (vers[0].position.transform t).y <= (vers[1].position.transform t).y)
						index= @vertices.index(vers[0])
					else
						index= @vertices.index(vers[1])
					end
					set_origin(index)  if index !=@origin_index
					reverse_axis if (@xaxis.normalize.transform t).y > (@yaxis.normalize.transform t).y
					if (@xaxis.normalize.transform t).x < 0
						next_origin
						reverse_axis if (@xaxis.normalize.transform t).y > (@yaxis.normalize.transform t).y
					end
				else
					vers =@vertices.sort{|a,b| (a.position.transform t).z <=> (b.position.transform t).z}
					if ((vers[0].position.transform t).x < (vers[1].position.transform t).x ) ||
					((vers[0].position.transform t).x == (vers[1].position.transform t).x and (vers[0].position.transform t).y <= (vers[1].position.transform t).y)
						index= @vertices.index(vers[0])
					else
						index= @vertices.index(vers[1])
					end
					set_origin(index) if index != @origin_index
					reverse_axis if (@xaxis.normalize.transform t).z > (@yaxis.normalize.transform t).z
				end
			end
			def get_vertices
				ver=[]
				vertices=[]
				vertices =@face.outer_loop.vertices*3
				(0..@face.outer_loop.vertices.length-1).each { |i|
					j=@face.outer_loop.vertices.length+i
					p1=vertices[j-1].position.clone
					p2=vertices[j].position.clone
					p3=vertices[j+1].position.clone
					v1=p1.vector_to p2
					v2=p2.vector_to p3
					ver.push vertices[j] if not ( v1.parallel? v2)
				}
				return ver
			end
			def setvar(first=false)
				if (@numver==4  and parallel?) or @numver==3
					@origin=@vertices[0].position
					@xaxis=@origin.vector_to @vertices[1].position
					@yaxis=@origin.vector_to @vertices[@numver-1].position
				else
					if @polygon
						@xaxis=@origin.vector_to @vertices[0].position
						@xaxis=@origin.vector_to @vertices[1].position if @xaxis.length==0
					else
						@origin=@vertices[0].position
						@xaxis=@origin.vector_to @vertices[1].position
					end
					@yaxis=@zaxis.cross @xaxis
					vy=@origin.vector_to @vertices[@numver-1].position
					#@yaxis.reverse! if(@yaxis.angle_between vy)> (Math::PI/ 2)
				end
				@transformation=transformation
				@trans_x=Geom::Transformation.new @xaxis,@zaxis.cross(@xaxis),@zaxis,@origin
				@trans_y=Geom::Transformation.new @yaxis.cross(@zaxis),@yaxis,@zaxis,@origin
				@minmax_x=@vertices.minmax_by{|v| v.position.transform(@trans_x.inverse).x}
				@minmax_y=@vertices.minmax_by{|v| v.position.transform(@trans_y.inverse).y}
			end
			def set_axis_points(view=Sketchup.active_model.active_view)
				# view=Sketchup.active_model.active_view
				size = view.pixels_to_model 50,@origin
				vecx=@xaxis.clone
				vecy=@yaxis.clone
				length=[@dx,@dy].min
				if vecx.length!=0 && vecy.length!=0
					vecx.length=size
					vecy.length=size
					(vecy.length = vecx.length = length) if length && (size > length)
					px=(@origin + vecx)
					py=(@origin + vecy)
					@vx=[@origin,px]
					@vy=[@origin,py]
					@axis_points=[px,py]
				end
			end
			def draw_origin(view,show_origin=@show_origin)
				# view=Sketchup.active_model.active_view
				set_axis_points view
				@show_origin=show_origin
				vers=@vertices.collect{|v| v.position}
				if Geom.point_in_polygon_2D(@origin,vers,true) || @show_origin
					view.line_width=4
					view.drawing_color="red"
					view.draw_line @vx
					view.drawing_color="green"
					view.draw_line @vy
					view.drawing_color= @start ?  "Orange" : "blueviolet"
					view.draw_line @vx[1],@vy[1]
				end
			end
			def draw_grid(view)
				# model=Sketchup.active_model
				# view=model.active_view
				# make_grid
				view.line_width=2
				view.drawing_color="blue"
				view.draw_lines @lines[0].flatten if @lines[0] && !@lines[0].flatten.empty?
				view.draw_lines @lines[1].flatten if @lines[1] && !@lines[1].flatten.empty?
			end
			def make_grid(axis_divide=@axis_divide,divide=nil,divide_mode=nil)
				@axis_divide=axis_divide
				# (divide=[];divide[0]=@divide[0];divide[1]=@divide[1]) if !divide
				divide_mode=@divide_mode if !divide_mode
				if divide
					divide_x=divide[0][divide_mode.x]
					divide_y=divide[1][divide_mode.y]
				else
					divide_x=@divide[0][divide_mode.x]
					divide_y=@divide[1][divide_mode.y]
				end
				lines=[]
				lines_x=[]
				lines_y=[]
				t=transformation
				yaxis=@zaxis.cross(@xaxis)
				yaxis=@xaxis.transform(Geom::Transformation.rotation @origin,@zaxis,Math::PI*0.5) if yaxis.length==0
				@trans_x=Geom::Transformation.new @xaxis,yaxis,@zaxis,@origin
				xaxis=@yaxis.cross(@zaxis)
				xaxis=@yaxis.transform(Geom::Transformation.rotation @origin,@zaxis,-Math::PI*0.5) if xaxis.length==0
				@trans_y=Geom::Transformation.new xaxis,@yaxis,@zaxis,@origin
				trans_x=@trans_x
				trans_y=@trans_y
				ver_trans_x=@vertices.collect{|v|v.position.transform(trans_x.inverse)}
				minmax_x_trans_x=ver_trans_x.minmax_by{|v| v.x}
				minmax_y_trans_x=ver_trans_x.minmax_by{|v| v.y}
				minmax_x_vertices_trans_x=@vertices.minmax_by{|v|v.position.transform(trans_x.inverse).x}
				minmax_y_vertices_trans_x=@vertices.minmax_by{|v|v.position.transform(trans_x.inverse).y}
				ver_trans_y=@vertices.collect{|v|v.position.transform(trans_y.inverse)}
				minmax_x_trans_y=ver_trans_y.minmax_by{|v| v.x}
				minmax_y_trans_y=ver_trans_y.minmax_by{|v| v.y}
				minmax_x_vertices_trans_y=@vertices.minmax_by{|v|v.position.transform(trans_y.inverse).x}
				minmax_y_vertices_trans_y=@vertices.minmax_by{|v|v.position.transform(trans_y.inverse).y}
				dx=minmax_x_trans_x[1].x-minmax_x_trans_x[0].x
				dy=minmax_y_trans_x[1].y-minmax_y_trans_x[0].y
				@dx,@dy=dx,dy
				s=Math.cos(@xaxis.angle_between(trans_y.xaxis)).abs
				return if ! s.between?(0.001,1)
				if @axis_divide & 1 ==1 # divide X
					if divide_mode.x==0
						step=dx.to_f/divide_x
					elsif divide_mode.x==1
						step=divide_x
						d=dx.divmod(step)
						step=dx.to_f/(d[0]+1) if d[1]!=0
					else
						step=divide_x
					end
					@step[0]=step
					st=step*s
					return if st==0
					p11= minmax_x_trans_y[0].clone
					n=p11.x.divmod(st)
					p1= Geom::Point3d.new( (n[0])*st,p11.y,p11.z)
					v = @yaxis.clone.transform trans_y.inverse
					v.length=dy
					p2 = p1 + v
					dmax=[dx,dy].max*2

					pp1= Geom::Point3d.new [0,0,0]
					pp2 = pp1 + v
					pp1.transform! trans_y
					pp2.transform! trans_y
					lines_x<<[pp1,pp2]
					if divide_mode.x!=3
						0.step(dmax,st){|s|
							v=X_AXIS.clone
							v.length=s
							p_1=(p1+v).transform trans_y
							p_2=(p2+v).transform trans_y
							lines_x<<[p_1,p_2] #if not lines_x.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}
						0.step(dmax,st){|s|
							v=X_AXIS.clone.reverse
							v.length=s
							p_1=(p1+v).transform trans_y
							p_2=(p2+v).transform trans_y
							lines_x<<[p_1,p_2] #if not lines_x.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}
					else
						length=0
						0.step(dmax,st){|s|
							v=X_AXIS.clone
							r1=rand(3).to_i
							length=length + st*r1
							v.length=length
							p_1=(p1+v).transform trans_y
							p_2=(p2+v).transform trans_y
							lines_x<<[p_1,p_2] #if not lines_x.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}
						0.step(dmax,st){|s|
							v=X_AXIS.clone.reverse
							r1=rand(3).to_i
							length=length + st*r1
							v.length=length
							p_1=(p1+v).transform trans_y
							p_2=(p2+v).transform trans_y
							lines_x<<[p_1,p_2] #if not lines_x.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}

					end
				end
				if @axis_divide & 2  == 2
					s=Math.cos(@yaxis.angle_between(trans_x.yaxis)).abs
					return if ! s.between?(0.001,1)
					if divide_mode.y==0
						step=dy.to_f/divide_y
					elsif divide_mode.y==1
						step=divide_y
						d=dy.divmod(step)
						step=dy.to_f/(d[0]+1) if d[1]!=0
					elsif divide_mode.y==2
						step=divide_y
					else
						step=divide_y
					end
					@step[1]=step
					st=step*s
					return if st==0
					p11= minmax_y_trans_x[0].clone
					n=p11.y.divmod(st)
					p1= Geom::Point3d.new( p11.x,(n[0])*st,p11.z)
					v = @xaxis.clone.transform trans_x.inverse
					v.length=dx
					p2 = p1 + v
					dmax=[dx,dy].max*2

					pp1= Geom::Point3d.new [0,0,0]
					pp2 = pp1 + v
					pp1.transform! trans_x
					pp2.transform! trans_x
					lines_x<<[pp1,pp2]
					if divide_mode.y!=3
						0.step(dmax,st){|s|
							v=Y_AXIS.clone
							v.length=s
							p_1=(p1+v).transform trans_x
							p_2=(p2+v).transform trans_x
							lines_y<<[p_1,p_2] #if not lines_y.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}
						0.step(dmax,st){|s|
							v=Y_AXIS.clone.reverse
							v.length=s
							p_1=(p1+v).transform trans_x
							p_2=(p2+v).transform trans_x
							lines_y<<[p_1,p_2] #if not lines_y.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}
					else
						length=0
						0.step(dmax,st){|s|
							v=Y_AXIS.clone
							r1=rand(3).to_i
							length=length + st*r1
							v.length=length
							p_1=(p1+v).transform trans_x
							p_2=(p2+v).transform trans_x
							lines_y<<[p_1,p_2] #if not lines_y.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}
						0.step(dmax,st){|s|
							v=Y_AXIS.clone.reverse
							r1=rand(3).to_i
							length=length + st*r1
							v.length=length
							p_1=(p1+v).transform trans_x
							p_2=(p2+v).transform trans_x
							lines_y<<[p_1,p_2] #if not lines_y.find{|l| (l.x==p_1 && l.y==p_2) || (l.y==p_1 || l.x==p_2) }
						}
					end
				end
				#@points=[[],[]]
				# lines=lines_x+lines_y
				if !lines_x.empty? && (@axis_divide & 1 ==1) && (@axis_divide & 8 == 0)
					@points=[] if !@points
					@points[0]=[]
					lines=lines_x
					lines_x.each{|l|
						l=[l[0],(l[0].vector_to l[1])]
						p = Geom.intersect_line_line(l, [@origin,@xaxis])
						@points.x<< p if p && [1,2,4].include?(@face.classify_point(p))
					}
					# lines_y.each{|l|
						# l=[l[0],(l[0].vector_to l[1])]
						# p = Geom.intersect_line_line(l, [@origin,@yaxis])
						# @points.y<< p if p && [1,2,4].include?(@face.classify_point(p))
					# }
					lines1=[]
					lines.each{|s|  lines1<<s if !lines1.include?(s) }
					lines.clear
					lines1.each{|l|
						points=[]
						@face.edges.each{|e|
							point = Geom.intersect_line_line(e.line, l)
							points<<point if point && Geom.point_in_polygon_2D(point,[e.start.position,e.end.position], true)
						}
						points.sort!{|a,b| [a.x,a.y,a.z] <=> [b.x,b.y,b.z] }
						(0..points.length-2).each{|i|
							p1=points[i]
							p2=points[i+1]
							if p1!= p2
								pl=@face.classify_point(Geom::Point3d.linear_combination(0.5,p1,0.5,p2))
								if (pl==1) || (pl==2) || (pl==4)
									lines << [p1,p2] if not lines.find{|l| (l.x==p1 || l.x==p2) && (l.y==p1 || l.y==p2) }
								end
							end
						}
					}
					@lines[0]=lines
					@divide[0][divide_mode.x]=divide_x
				elsif (@axis_divide & 1 !=1)
					@points=[] if !@points
					@points[0]=[]
					@lines[0]=[]
					#@divide[0][divide_mode.x]=divide_x
				end
				if !lines_y.empty? && (@axis_divide & 2 ==2) && (@axis_divide & 4 == 0)
					@points=[] if !@points
					@points[1]=[]
					lines=lines_y
					# lines_x.each{|l|
						# l=[l[0],(l[0].vector_to l[1])]
						# p = Geom.intersect_line_line(l, [@origin,@xaxis])
						# @points.x<< p if p && [1,2,4].include?(@face.classify_point(p))
					# }
					lines_y.each{|l|
						l=[l[0],(l[0].vector_to l[1])]
						p = Geom.intersect_line_line(l, [@origin,@yaxis])
						@points.y<< p if p && [1,2,4].include?(@face.classify_point(p))
					}
					lines1=[]
					lines.each{|s|  lines1<<s if !lines1.include?(s) }
					lines.clear
					lines1.each{|l|
						points=[]
						@face.edges.each{|e|
							point = Geom.intersect_line_line(e.line, l)
							points<<point if point && Geom.point_in_polygon_2D(point,[e.start.position,e.end.position], true)
						}
						points.sort!{|a,b| [a.x,a.y,a.z] <=> [b.x,b.y,b.z] }
						(0..points.length-2).each{|i|
							p1=points[i]
							p2=points[i+1]
							if p1!= p2
								pl=@face.classify_point(Geom::Point3d.linear_combination(0.5,p1,0.5,p2))
								if (pl==1) || (pl==2) || (pl==4)
									lines << [p1,p2] if not lines.find{|l| (l.x==p1 || l.x==p2) && (l.y==p1 || l.y==p2) }
								end
							end
						}
					}
					@lines[1]=lines
					@divide[1][divide_mode.y]=divide_y
				elsif (@axis_divide & 2 !=2)
					@points=[] if !@points
					@points[1]=[]
					@lines[1]=[]
					# @divide[1][divide_mode.y]=divide_y
				end
				if !@points
					@points=[[],[]]
					@lines=[[],[]]
				end
				@divide_mode=divide_mode
				# rescue
				# p "error"
			end
			def copy(f,make_grid=true)
				if @zaxis.parallel? f.zaxis
					if @origin.on_plane?(f.face.plane)
						@origin,@xaxis,@yaxis=f.origin,f.xaxis,f.yaxis
					else
						@xaxis,@yaxis=f.xaxis,f.yaxis
						@origin=f.origin.project_to_plane(@face.plane)
					end
				else
					line=Geom::intersect_plane_plane(f.face.plane,@face.plane)
					if line
						angle=f.zaxis.angle_between @zaxis
						t=Geom::Transformation.rotation line[0],line[1],angle
						@origin=f.origin.transform t
						@xaxis=f.xaxis.transform t
						@yaxis=f.yaxis.transform t
						# line_x=[f.origin,(f.origin+f.xaxis)]
						# line_y=[f.origin,(f.origin+f.yaxis)]
						# px=Geom::intersect_line_plane(line_x,@face.plane)
						# py=Geom::intersect_line_plane(line_y,@face.plane)
						# angle=@zaxis.angle_between f.zaxis
						# t=Geom::Transformation.rotation line[0],line[1],angle
						# @origin=f.origin.transform t
						# @xaxis,@yaxis=f.xaxis,f.yaxis
						# @xaxis=px-@origin if px && px!=@origin
						# @yaxis=py-@origin if py && py!=@origin
					end
				end
				@divide=f.divide
				@divide_mode=f.divide_mode
				make_grid(@axis_divide,@divide,@divide_mode) if make_grid
			end
			def next_origin
				@origin_index=@origin_index+1
				@origin_index=@origin_index.divmod(4)[1]
				vers=@vertices*2
				@vertices.clear
				@vertices=vers[1..@numver]
				self.setvar
			end
			def reverse_axis
				@rever=1-@rever
				@vertices=@vertices[1..(@numver-1)].reverse.unshift @vertices[0]
				setvar
			end
			def set_origin(index=nil)
				vers=@vertices*2
				if !index
					ver=@vertices.sort_by{|v| v.position.z && v.position.x}[0,2].sort_by{|v| v.position.y}[0]
					index=@vertices.index(ver)
				end
				length=@vertices.length+index-1
				@vertices.clear
				@vertices=vers[index..length]
				setvar
			end
			def polygon?
				cp1=self.center_face
				@polygon=true
				(1..@numver-1).each{|i|
					if (cp1.distance @vertices[0].position) != (cp1.distance @vertices[i].position)
						@polygon=false
						return nil
					end
				}
				return cp1 if @polygon
			end
			def parallel?
				if  @numver==4
					vers=@vertices
					v1=vers[0];v2=vers[1];v3=vers[2];vend=vers[3]
					vend_v3=vend.position.vector_to v3.position
					vx = v1.position.vector_to v2.position
					vy = v1.position.vector_to vend.position
					return true if (vend_v3.samedirection? vx and vend_v3.length==vx.length)
				end
				return false
			end
			def center_face
				cp=Geom::Point3d.new
				@vertices.each{|v|
					cp.x=cp.x+v.position.x
					cp.y=cp.y+v.position.y
					cp.z=cp.z+v.position.z
				}
				cp.x=cp.x/ @numver
				cp.y=cp.y/ @numver
				cp.z=cp.z/ @numver
				return cp
			end
		end #end class
		def self.main(mode=0)
			model=Sketchup.active_model
			sels=model.selection.grep(Sketchup::Face)
			if sels.empty?
				UI.messagebox(S4U::S4u_Divide::Strings["Select Faces"])
				return
			end
			Sketchup.active_model.select_tool S4U::S4u_Divide::DivideFaces.new(mode)
		end
	end
end